
#include <avr/io.h>
#include <stdio.h>
#include <inttypes.h>
#define F_CPU 1000000 // CPU-Frequenz in Hz
#include <util/delay.h>
#include <avr/interrupt.h>
#include "lcd-routines.h"

volatile int timer;

ISR(TIMER1_OVF_vect){
	TCNT1 = 49911;
	timer++;
}

int main(void){

        int  stunden=20, minuten=33, sekunden=0;	 //hier bitte die Uhrzeit einstellen
	char sekundenstring[3], minutenstring[3], stundenstring[3];

        DDRB |= _BV(PB0); PORTB &= ~_BV(PB0);  // PB0 ist Status-LED Ausgang
	
	//Timer 1 initialisieren:
	TIMSK |= _BV(TOIE1); 	//aktivieren des berlaufinterrupts von Timer1 
	TCCR1B = _BV(CS11) |  _BV(CS10); 	//Prescaler = 64
	TCNT1 = 0xFFFF; 		//Zhlregister vorladen mit FFFF zum Sofortstart 
	
	sei();	//Interrupts aktivieren
	
	lcd_init();
	lcd_clear();
	
	set_cursor (3, 1); lcd_string ("Uhrzeit");
	set_cursor (5, 2);lcd_string (":");set_cursor (8, 2);lcd_string (":");		
	
	sprintf(stundenstring, "%d", stunden);
	set_cursor (3, 2);
	if (stunden<10) lcd_string ("0");
	lcd_string (stundenstring);
	
	sprintf(minutenstring, "%d", minuten);
	set_cursor (6, 2);
	if (minuten<10) lcd_string ("0");
	lcd_string (minutenstring);
				
	sprintf(sekundenstring, "%d", sekunden);
	set_cursor (9, 2);
	if (sekunden<10) lcd_string ("0");	
	lcd_string (sekundenstring);


	
	while(1){
			
		if (sekunden!=timer) {
			
			sekunden=timer;
			
			if (sekunden==60){
				timer=0;	sekunden=0; minuten++;
				
				if (minuten==60){
					minuten=0; 
					stunden++;
					if (stunden==24) stunden=0;
				}
				sprintf(minutenstring, "%d", minuten);
				set_cursor (6, 2);
				if (minuten<10) lcd_string ("0");
				lcd_string (minutenstring);
				
				
				sprintf(stundenstring, "%d", stunden);
				set_cursor (3, 2);
				if (stunden<10) lcd_string ("0");
				lcd_string (stundenstring);
			}
						
			sprintf(sekundenstring, "%d", sekunden); 
			set_cursor (9, 2);
			if (sekunden<10) lcd_string ("0");
			lcd_string (sekundenstring);
					
		}

	}	
 
	return(0);
}


